package {
	import flash.display.Sprite;
	import flash.events.Event;
	import shape.Box;
	import geom.Vector3D;
	import geom.Matrix4;
	import flash.geom.Matrix;

	public class Screen extends Sprite
	{
		private var box:Box;
		private var light:Vector3D = new Vector3D(-100,80,120);
		private var rx:Number = 0.1;
		private var ry:Number = 0.05;

		public function Screen()
		{
			init();
		}

		private function init():void
		{
			light.normalize();
			box = new Box(50);
			box.setPosition(stage.stageWidth/2,stage.stageHeight);
			box.setAmbientColor(0.2,0.4,0.2);
			box.setDiffuseColor(0.1,0.7,0.1);
			addChild(box);
			stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}
		
		private function onEnterFrame(event:Event):void
		{
			rx += 0.1;
			ry += 0.05;
			var matX:Matrix4 = new Matrix4();
			var matY:Matrix4 = new Matrix4();
			matX.rotX(rx);
			matY.rotY(ry);
			var mat:Matrix4 = new Matrix4();
			mat.setIdentity();
			mat.mul(matX, matY);
			box.rotMat = mat;
			box.draw(light);
		}
	}
}
