package geom
{
	import flash.geom.Matrix;
	
	public class Matrix4
	{
		private var m00:Number;
		private var m01:Number;
		private var m02:Number;
		private var m03:Number;
		private var m10:Number;
		private var m11:Number;
		private var m12:Number;
		private var m13:Number;
		private var m20:Number;
		private var m21:Number;
		private var m22:Number;
		private var m23:Number;
		private var m30:Number;
		private var m31:Number;
		private var m32:Number;
		private var m33:Number;
		
		public function Matrix4(
			m00:Number=0, m01:Number=0, m02:Number=0, m03:Number=0,
			m10:Number=0, m11:Number=0, m12:Number=0, m13:Number=0,
			m20:Number=0, m21:Number=0, m22:Number=0, m23:Number=0,
			m30:Number=0, m31:Number=0, m32:Number=0, m33:Number=0
			)
		{
			set(m00,m01,m02,m03,m10,m11,m12,m13,m20,m21,m22,m23,m30,m31,m32,m33);
		}
		
		public function set(
			m00:Number, m01:Number, m02:Number, m03:Number,
			m10:Number, m11:Number, m12:Number, m13:Number,
			m20:Number, m21:Number, m22:Number, m23:Number,
			m30:Number, m31:Number, m32:Number, m33:Number
			):void
		{
			this.m00 = m00;
			this.m01 = m01;
			this.m02 = m02;
			this.m03 = m03;
			this.m10 = m10;
			this.m11 = m11;
			this.m12 = m12;
			this.m13 = m13;
			this.m20 = m20;
			this.m21 = m21;
			this.m22 = m22;
			this.m23 = m23;
			this.m30 = m30;
			this.m31 = m31;
			this.m32 = m32;
			this.m33 = m33;
		}

		public function setZero():void
		{
			m00 = 0;
			m01 = 0;
			m02 = 0;
			m03 = 0;
			m10 = 0;
			m11 = 0;
			m12 = 0;
			m13 = 0;
			m20 = 0;
			m21 = 0;
			m22 = 0;
			m23 = 0;
			m30 = 0;
			m31 = 0;
			m32 = 0;
			m33 = 0;
		}
		
		public function setIdentity():void
		{
	        m00 = 1.0; m01 = 0.0; m02 = 0.0; m03 = 0.0;
	        m10 = 0.0; m11 = 1.0; m12 = 0.0; m13 = 0.0;
	        m20 = 0.0; m21 = 0.0; m22 = 1.0; m23 = 0.0;
	        m30 = 0.0; m31 = 0.0; m32 = 0.0; m33 = 1.0;
		}
		
		public function addScalar(scalar:Number):void
		{
			m00 += scalar; m01 += scalar; m02 += scalar; m03 += scalar;
			m10 += scalar; m11 += scalar; m12 += scalar; m13 += scalar;
			m20 += scalar; m21 += scalar; m22 += scalar; m23 += scalar;
			m30 += scalar; m31 += scalar; m32 += scalar; m33 += scalar;
		}
		
		public function add(mat:Matrix4):void
		{
			m00 += mat.m00; m01 += mat.m01; m02 += mat.m02; m03 += mat.m03;
			m10 += mat.m10; m11 += mat.m11; m12 += mat.m12; m13 += mat.m13;
			m20 += mat.m20; m21 += mat.m21; m22 += mat.m22; m23 += mat.m23;
			m30 += mat.m30; m31 += mat.m31; m32 += mat.m32; m33 += mat.m33;
		}
		
		public function sub(mat:Matrix4):void
		{
			m00 -= mat.m00; m01 -= mat.m01; m02 -= mat.m02; m03 -= mat.m03;
			m10 -= mat.m10; m11 -= mat.m11; m12 -= mat.m12; m13 -= mat.m13;
			m20 -= mat.m20; m21 -= mat.m21; m22 -= mat.m22; m23 -= mat.m23;
			m30 -= mat.m30; m31 -= mat.m31; m32 -= mat.m32; m33 -= mat.m33;
		}
		
		public function transpose():void
		{
			var tmp:Number = m01;
			m01 = m10;
			m10 = tmp;
		
			tmp = m02;
			m02 = m20;
			m20 = tmp;
		
			tmp = m03;
			m03 = m30;
			m30 = tmp;
		
			tmp = m12;
			m12 = m21;
			m21 = tmp;
		
			tmp = m13;
			m13 = m31;
			m31 = tmp;
		
			tmp = m23;
			m23 = m32;
			m32 = tmp;
		}
		
		public function rotX(angle:Number):void
		{
			var c:Number = Math.cos(angle);
			var s:Number = Math.sin(angle);
		
			m00 = 1.0; m01 = 0.0; m02 = 0.0; m03 = 0.0;
			m10 = 0.0; m11 = c;   m12 = -s;  m13 = 0.0;
			m20 = 0.0; m21 = s;   m22 = c;   m23 = 0.0;
			m30 = 0.0; m31 = 0.0; m32 = 0.0; m33 = 1.0; 
		}
		
		public function rotY(angle:Number):void
		{
			var c:Number = Math.cos(angle);
			var s:Number = Math.sin(angle);

			m00 = c;   m01 = 0.0; m02 = s;   m03 = 0.0;
			m10 = 0.0; m11 = 1.0; m12 = 0.0; m13 = 0.0;
			m20 = -s;  m21 = 0.0; m22 = c;   m23 = 0.0;
			m30 = 0.0; m31 = 0.0; m32 = 0.0; m33 = 1.0; 
		}
		
		public function rotZ(angle:Number):void
		{
			var c:Number = Math.cos(angle);
			var s:Number = Math.sin(angle);
			
			m00 = c;   m01 = -s;  m02 = 0.0; m03 = 0.0;
			m10 = s;   m11 = c;   m12 = 0.0; m13 = 0.0;
			m20 = 0.0; m21 = 0.0; m22 = 1.0; m23 = 0.0;
			m30 = 0.0; m31 = 0.0; m32 = 0.0; m33 = 1.0; 
		}
		
		public function mulScalar(scalar:Number):void
		{
			m00 *= scalar; m01 *= scalar; m02 *= scalar; m03 *= scalar;
			m10 *= scalar; m11 *= scalar; m12 *= scalar; m13 *= scalar;
			m20 *= scalar; m21 *= scalar; m22 *= scalar; m23 *= scalar;
			m30 *= scalar; m31 *= scalar; m32 *= scalar; m33 *= scalar;
		}
		
		public function mul(m1:Matrix4, m2:Matrix4):void
		{
			set(
			    m1.m00*m2.m00 + m1.m01*m2.m10 + m1.m02*m2.m20 + m1.m03*m2.m30,
			    m1.m00*m2.m01 + m1.m01*m2.m11 + m1.m02*m2.m21 + m1.m03*m2.m31,
			    m1.m00*m2.m02 + m1.m01*m2.m12 + m1.m02*m2.m22 + m1.m03*m2.m32,
			    m1.m00*m2.m03 + m1.m01*m2.m13 + m1.m02*m2.m23 + m1.m03*m2.m33,
		
			    m1.m10*m2.m00 + m1.m11*m2.m10 + m1.m12*m2.m20 + m1.m13*m2.m30,
			    m1.m10*m2.m01 + m1.m11*m2.m11 + m1.m12*m2.m21 + m1.m13*m2.m31,
			    m1.m10*m2.m02 + m1.m11*m2.m12 + m1.m12*m2.m22 + m1.m13*m2.m32,
			    m1.m10*m2.m03 + m1.m11*m2.m13 + m1.m12*m2.m23 + m1.m13*m2.m33,
		
			    m1.m20*m2.m00 + m1.m21*m2.m10 + m1.m22*m2.m20 + m1.m23*m2.m30,
			    m1.m20*m2.m01 + m1.m21*m2.m11 + m1.m22*m2.m21 + m1.m23*m2.m31,
			    m1.m20*m2.m02 + m1.m21*m2.m12 + m1.m22*m2.m22 + m1.m23*m2.m32,
			    m1.m20*m2.m03 + m1.m21*m2.m13 + m1.m22*m2.m23 + m1.m23*m2.m33,
		
			    m1.m30*m2.m00 + m1.m31*m2.m10 + m1.m32*m2.m20 + m1.m33*m2.m30,
			    m1.m30*m2.m01 + m1.m31*m2.m11 + m1.m32*m2.m21 + m1.m33*m2.m31,
			    m1.m30*m2.m02 + m1.m31*m2.m12 + m1.m32*m2.m22 + m1.m33*m2.m32,
			    m1.m30*m2.m03 + m1.m31*m2.m13 + m1.m32*m2.m23 + m1.m33*m2.m33
			    );
		}
		
		public function transform(v:Vector3D):Vector3D
		{
			return new Vector3D(
			    m00*v.x + m01*v.y + m02*v.z + m03,
			    m10*v.x + m11*v.y + m12*v.z + m13,
			    m20*v.x + m21*v.y + m22*v.z + m23
			    );
		}
	}
}