package geom
{
	import flash.display.Graphics;
	
	public class Triangle
	{
		public var vertex:Array = new Array();
		public var normal:Vector3D;
		
		public function Triangle(v1:Vector3D, v2:Vector3D, v3:Vector3D)
		{
			vertex[0] = v1.clone();
			vertex[1] = v2.clone();
			vertex[2] = v3.clone();
			
			calcNormal();
		}

		private function calcNormal():void
		{
			var v1:Vector3D = vertex[0];
			var v2:Vector3D = vertex[1];
			var v3:Vector3D = vertex[2];
			
			// 面法線の計算
			var a:Vector3D = v2.sub(v1);
			var b:Vector3D = v3.sub(v1);
			normal = a.crossProduct(b);
			normal.normalize();
		}
		
		public function transform(mat:Matrix4):Triangle
		{
			var v1:Vector3D = mat.transform(vertex[0]);
			var v2:Vector3D = mat.transform(vertex[1]);
			var v3:Vector3D = mat.transform(vertex[2]);

			return new Triangle(v1,v2,v3);
		}
	}
}