package geom
{
	public class Vector3D
	{
		public var x:Number;
		public var y:Number;
		public var z:Number;
		
		public function Vector3D(x:Number, y:Number, z:Number)
		{
			this.x = x;
			this.y = y;
			this.z = z;
		}

		// 内積
		public function dotProduct(vec:Vector3D):Number
		{
			return this.x*vec.x + this.y*vec.y + this.z*vec.z;
		}
		
		// 外積
		public function crossProduct(vec:Vector3D):Vector3D
		{
			var x:Number = this.y*vec.z-this.z*vec.y;
			var y:Number = this.z*vec.x-this.x*vec.z;
			var z:Number = this.x*vec.y-this.y*vec.x;
			
			return new Vector3D(x,y,z);
		}
		
		// 正規化
		public function normalize():void
		{
			var length:Number = Math.sqrt(x*x+y*y+z*z);

			// 零ベクトルの場合は何もしない
			if(length == 0)
				return;

			x /= length;
			y /= length;
			z /= length;
		}
		
		// 複製
		public function clone():Vector3D
		{
			return new Vector3D(x,y,z);
		}
		
		// 和
		public function add(v:Vector3D):Vector3D
		{
			return new Vector3D(this.x+v.x, this.y+v.y, this.z+v.z);
		}
		
		// 差
		public function sub(v:Vector3D):Vector3D
		{
			return new Vector3D(this.x-v.x, this.y-v.y, this.z-v.z);
		}
	}
}